/* ******************************************************** */
/*   FAST TRANSFER tintin++ alias&action files to ht file   */
/* This won't do perfect job but atleast it do most work... */
/*                  coded by Ossi Tulonen 1994              */
/*                                                          */
/* $Log: transfer.c,v $
 * Revision 1.9  1994/11/26  06:20:40  oat
 * v1.1
 *
 * Revision 1.8  1994/11/10  19:16:21  oat
 * better argument handling.
 *
 * Revision 1.7  1994/11/10  13:59:40  oat
 * added command 'nop'
 * added flags -o and -O: old file is tintin III file not tintin++.
 *
 * Revision 1.6  1994/10/04  14:01:22  oat
 * ht v 1.0 beta
 *
 * Revision 1.5  1994/09/14  23:16:17  oat
 * fixed #math command transfer.
 *
 * Revision 1.4  1994/09/14  16:14:27  oat
 * make get_arg_with_spaces() fo better work with bracers.
 *
 * Revision 1.3  1994/09/14  06:00:30  oat
 * added verbose mode.
 * better transfer...;)
 *                                                    */
/* ******************************************************** */

#include <stdio.h>
#ifndef NSTDLIBS
#  include <stdlib.h>
#endif
#include <assert.h>
#include <ctype.h>
#include <strings.h>

#define BUFFER_SIZE 10000
#define TRUE 1
#define FALSE 0

char tintin_char = '\0';
char old_text_start = '{';
char old_text_end   = '}';
char old_variable_char = '%';

char new_tintin_char = '#';
char new_text_start  = '[';
char new_text_end    = ']';
char new_variable_char = '$';

int old_tintin = FALSE;

char *commands[] = {
  "action",           /* 0  */
  "alias",
  "all",
  "antisubstitute",
  "bell",
  "boss", 
  "char",
  "cr",
  "echo",
  "end", 
  "help",             /* 10 */
  "highlight",
  "history", 
  "if", 
  "ignore",
  "info",
  "killall",
  "log", 
  "loop",
  "nop",
  "map",              /* 20 */
  "math", 
  "mark", 
  "message",
  "path", 
  "pathdir", 
  "presub",
  "redraw",
  "retab",
  "return",
  "read",             /* 30 */
  "savepath",
  "session",
  "showme",
  "snoop",
  "speedwalk",
  "split",
  "suspend",
  "tablist",
  "tabadd",
  "tabdelete",        /* 40 */
  "textin",
  "unsplit",
  "substitute",
  "gag",
  "system",
  "tick", 
  "tickoff", 
  "tickon", 
  "tickset",
  "ticksize",         /* 50 */
  "togglesubs",
  "unaction",
  "unalias",
  "unantisubstitute",
  "unhighlight",
  "unsubstitute",
  "ungag",
  "unpath", 
  "variable",
  "version",          /* 60 */
  "unvariable",
  "wizlist", 
  "write",
  "writesession",
  "zap",              /* 65 */
  "\n"
};

int is_abrev(const char *s1, const char *s2)
{
  while(*s1 && *s2)
    if(*s1++ != *s2++)
      return(FALSE);
  
  if(*s1 || (!*s1 && !*s2))
    return(TRUE);
  
  return(FALSE);
}

int str_cat(char *s, int len, int maxlen, const char *append)
{
  int i;
  
  assert(len <= maxlen);
  
  for ( i = 0; len + i < maxlen - 1 && *(append + i) != '\0'; i++)
    *(s + len + i) = *(append + i);
  
  *(s + len + i) = '\0';
  
  if(*(append + i) != '\0') {
    fprintf(stderr,
	    "### BUG: too long append(%d/%d) string in str_cat(max %d)\n%s",
	    i, (int)strlen(append),
	    maxlen,
	    append);
  }
  
  return(len + i);
}

const char *get_arg_all(const char *text, char *buf)
{
  int inside = 0;
  
  while(isspace(*text))
    text++;

  if(old_tintin) {
    while(*text) {
      
      if(*text == '\\') {
	*buf++ = *text++;
	if(*text)
	  *buf++ = *text++;
      } else if(*text == '"') {
	*buf++ = *text++;
	inside = !inside;
      } else if(*text == ';') {
	if(inside)
	  *buf++ = *text++;
	else
	  break;
      } else
	*buf++ = *text++;
    }
  } else {
    while(*text) {
      if(!inside && *text == ';')
	break;
      
      if(*text == old_text_start) {
	inside++;
	*buf++ = *text++;
      } else if(*text == old_text_end) {
	if(inside > 0)
	  inside--;
	*buf++ = *text++;
      } else if(*text == '\\') {
	*buf++ = *text++;
	if(*text)
	  *buf++ = *text++;
      } else {
	*buf++ = *text++;
      }
    }
  }
  *buf = '\0';
  
  return(text);
}

const char *get_arg_stop_spaces(const char *s, char *arg)
{
  int inside = 0;

  while(isspace(*s))
    s++;

  if(old_tintin) {
    while(*s) {
      if(*s == '\\') {
	if(*++s)
	  *arg++ = *s++;
      } else if(*s == '"') {
	s++;
	inside = !inside;
      } else if(*s == ';') {
	if(inside)
	  *arg++ = *s++;
	else
	  break;
      } else if(!inside && isspace(*s))
	break;
      else
	*arg++=*s++;
    }
  } else {
    while(*s) {
      if((*s == ';' || isspace(*s)) && !inside)
	break;
      
      if(*s == old_text_start) {
	if(inside)
	  *arg++ = *s++;
	else
	  s++;
	inside++;
      } else if(*s == old_text_end) {
	if(inside)
	  inside--;
	if(inside)
	  *arg++ = *s++;
	else {
	  s++;
	}
      } else if(*s == '\\') {
	*arg++ = *s++;
	if(*arg)
	  *arg++ = *s++;
      } else {
	*arg++ = *s++;
      }
    }
  }
  *arg = '\0';
  return s;
}

const char *get_arg_with_spaces(const char *s, char *arg)
{
  int inside = 0, found = FALSE;
  
  while(isspace(*s))
    s++;

  if(old_tintin) {
    while(*s) {
      if(*s == '\\') {
	if(*++s)
	  *arg++ = *s++;
      } else if(*s == '"') {
	s++;
	inside = !inside;
      } else if(*s == ';') {
	if(inside)
	  *arg++ = *s++;
	else
	  break;
      } else
	*arg++ = *s++;
    }
  } else {
    if(*s == old_text_start) {
      inside++;
      found = TRUE;
      s++;
    }
  
    while(*s) {
      if(*s == ';' && !inside)
	break;
      
      if(*s == old_text_start) {
	if(inside || !found)
	  *arg++ = *s++;
	else
	  s++;
	inside++;
      } else if(*s == old_text_end) {
	if(inside)
	  inside--;
	if(inside || !found)
	  *arg++ = *s++;
	else {
	  s++;
	}
      } else if(*s == '\\') {
	*arg++ = *s++;
	if(*arg)
	  *arg++ = *s++;
      } else {
	*arg++ = *s++;
      }
    }
  }

  *arg = '\0';
  return s;
}

void trans(const char *str, char *buf);

int main(int argc, char **argv)
{
  char buffer[BUFFER_SIZE], line[4096], *linepos;
  char result[BUFFER_SIZE], *tmp, *oldname = 0, *newname = 0;
  int pos, verbose = FALSE, i, nextisname = FALSE;
  FILE *oldfl, *newfl;
  
  for(i = 1; i < argc; i++) {
    tmp = argv[i];
    while(isspace(*tmp))
      tmp++;
    
    if(*tmp == '-' && !nextisname) {
      tmp++;
    
      while(*tmp) {
	switch(*tmp) {
	case '-':
	  nextisname = TRUE;
	  tmp++;
	  break;
	case 'v':
	case 'V':
	  verbose = TRUE;
	  tmp++;
	  break;
	case 'o':
	case 'O':
	  old_tintin = TRUE;
	  tintin_char = '#';
	  old_text_start = '"';
	  old_text_end   = '"';
	  old_variable_char = '&';
	  tmp++;
	  break;
	default:
	  printf("Illegal option %c.\n", *tmp);
	  tmp++;
	} /* switch */
      }
    } else if(*tmp) {
      nextisname = FALSE;
      
      if(!oldname)
	oldname = tmp;
      else if(!newname)
	newname = tmp;
      else
	printf("Too many names.\n");
    }
  }
  if(!newname) {
    printf("Usage: %s [-vVoO] <OLD FILE NAME> <NEW FILE NAME>\n\r", argv[0]);
    exit(0);
  }
  
  if(strcmp(oldname, newname) == 0) {
    printf("File names must be diffirent.\n\r");
    exit(0);
  }
  if((oldfl = fopen(oldname, "rt")) == 0) {
    perror(oldname);
    exit(0);
  }
  if((newfl = fopen(newname, "wt")) == 0) {
    perror(newname);
    exit(1);
  }

  while(fgets(line, sizeof(line), oldfl)) {
    linepos = line;
    while(isspace(*linepos))
      linepos++;

    if(!tintin_char)
      tintin_char = *linepos;
    
    pos = str_cat(buffer, 0, sizeof(buffer), linepos);
    if(*(buffer + pos - 1) == '\n')
      pos--;
    
    while(isspace(*(buffer + pos - 1)) && pos > 0)
      pos--;

    while(pos > 0 &&
	  *(buffer + pos - 1) == '\\' &&
	  fgets(line, sizeof(line), oldfl)) {
      linepos = line;
      while(isspace(*linepos))
	linepos++;

      pos = str_cat(buffer, pos - 1, sizeof(buffer), linepos);
      if(*(buffer + pos - 1) == '\n')
	pos--;

      while(isspace(*(buffer + pos - 1)) && pos > 0)
	pos--;
    }
    *(buffer + pos) = '\0';

    if(!*buffer)
      continue;
    
    trans(buffer, result);
    if(*result) {
      fprintf(newfl, "%s\n", result);
      if(verbose) {
	printf("Old Line: %s\n", buffer);
	printf("New Line: %s\n\n", result);
      }
    }
  }
  fclose(oldfl);
  fclose(newfl);
  exit(0);
}

void trans_arg(const char *arg, char *result)
{
  if(old_tintin) {
    while(*arg) {
      if(*arg == '\\') {
	*result++ = *arg++;
	if(*arg) {
	  *result++ = *arg++;
	}	
      } else if(*arg == old_variable_char) {
	*result++ = new_variable_char;
	arg++;
	if(*arg)
	  *result++ = *arg++;
	
      } else {
	*result++ = *arg++;
      }
    }
    
  } else {

    while(*arg) {
      if(*arg == '\\') {
	*result++ = *arg++;
	if(*arg)
	  *result++ = *arg++;
	
      } else if(*arg == old_variable_char) {
	while(*arg == old_variable_char) {
	  *result++ = new_variable_char;
	  arg++;
	}
	if(*arg)
	  *result++ = *arg++;
	
      } else if(*arg == '$') {
	while(*arg == '$') {
	  *result++ = new_variable_char;
	  arg++;
	}
	
	if(*arg >= '0' && *arg <= '9')
	  *result++ = *arg++;
	else {
	  while(isalpha(*arg))
	    *result++ = *arg++;
	  *result++ = new_variable_char;
	}
	
      } else {
	*result++ = *arg++;
      }
    }
  }
  *result = '\0';
}

void trans(const char *str, char *buf)
{
  const char *line;
  char buffer[BUFFER_SIZE], *command, combuf[BUFFER_SIZE];
  char tmp[BUFFER_SIZE], tmp2[BUFFER_SIZE];
  int pos = 0, inside, num, found, i;
  
  while(*str) {
    str = get_arg_all(str, buffer);

    line = buffer;
    
    if(*line == tintin_char) {
      inside = 0;
      
      line++;
      
      command = combuf;
      while(*line > ' ')
	*command++ = *line++;
      
      *command = '\0';
      
      for(num = 0; *commands[num] != '\n'; num++)
	if(is_abrev(commands[num], combuf))
	  break;

      if(*commands[num] == '\n') {
	if(isdigit(*combuf))
	  num = 2;            /* handled like all command */
      }
      
      if(*commands[num] != '\n') {
	while(isspace(*line))
	  line++;
	
	found = FALSE;
	switch(num) {
	case 0:                /* action */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_stop_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  if(found)
	    buf[pos++] = new_text_end;

	  while(isspace(*line))
	    line++;

	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    buf[pos++] = new_text_start;
	    if(old_tintin)
	      line = get_arg_with_spaces(line, tmp);
	    else
	      line = get_arg_stop_spaces(line, tmp);
	    trans(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	    buf[pos++] = new_text_end;
	  }
	  break;
	case 1:                /* alias  */
	case 13:               /* if     */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_stop_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  if(found)
	    buf[pos++] = new_text_end;

	  while(isspace(*line))
	    line++;

	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    found = FALSE;
	    if(*line == old_text_start) {
	      found = TRUE;
	      buf[pos++] = new_text_start;
	    }
	    line = get_arg_with_spaces(line, tmp);
	    trans(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	    if(found)
	      buf[pos++] = new_text_end;
	  }
	  break;
	case 2:               /* all     */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_with_spaces(line, tmp);
	  trans(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  
	  if(found)
	    buf[pos++] = new_text_end;
	  break;
/*	case 3:   */          /* antisub */
	case 6:             /* char    */
	case 10:            /* help    */
	case 17:            /* log     */
	case 30:            /* read    */
	case 31:            /* savepath */
	case 33:            /* showme  */
	case 34:            /* snoop   */
	case 36:            /* split   */
	case 50:            /* ticksize */
	case 52:            /* unaction */
	case 53:            /* unalias  */
	case 56:            /* unsubstitute */
	case 61:            /* unvariable */
	case 63:            /* write   */
	case 64:            /* writesession */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_with_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  
	  if(found)
	    buf[pos++] = new_text_end;
	  break;
	case 4:              /* bell   */
	case 5:              /* boss   */
/*	case 7:    */          /* cr     */
	case 9:              /* end    */
	case 22:             /* mark   */
	case 24:             /* path   */
	case 29:             /* return */
	case 35:             /* speedwalk */
	case 46:             /* tick   */
	case 47:             /* tickoff */
	case 48:             /* tickon */
	case 49:             /* tickset */
	case 58:             /* unpath */
	case 60:             /* version */
	case 65:             /* zap    */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  break;
	case 8:               /* echo */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ac");
	  break;
	case 14:              /* ignore */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ac");
	  break;
	case 18:             /* loop   */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "for");
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  line = get_arg_stop_spaces(line, tmp);
	  
	  for(i = 0; *(tmp + i) && *(tmp + i) != ','; i++)
	    ;

	  found = FALSE;
	  if(*(tmp + i) == ',') {
	    found = TRUE;
	    *(tmp + i) = '\0';
	  }

	  buf[pos++] = new_text_start;
	  if(*tmp) {
	    trans_arg(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  } else {
	    pos = str_cat(buf, pos, BUFFER_SIZE, "0");
	  }
	  buf[pos++] = new_text_end;
	  buf[pos++] = ' ';
	  
	  buf[pos++] = new_text_start;
	  if(found && *(tmp + i + 1)) {
	    i++;
	    trans_arg(tmp + i, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  } else {
	    buf[pos++] = '0';
	  }
	  buf[pos++] = new_text_end;

	  while(isspace(*line))
	    line++;
	  
	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    found = FALSE;
	    if(*line == old_text_start) {
	      found = TRUE;
	      buf[pos++] = new_text_start;
	    }
	    line = get_arg_stop_spaces(line, tmp);
	    trans(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	    if(found)
	      buf[pos++] = new_text_end;
	  }
	  break;
	case 19:              /* nop    */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  while(*line) {
	    switch(*line) {
	    case '@':
	    case '$':
	      buf[pos++] = '\\';
	      buf[pos++] = *line;
	      break;
	    default:
	      buf[pos++] = *line;
	      break;
	    }
	    line++;
	  }
	  buf[pos] = '\0';
	  break;
	case 21:              /* math    */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "variable ");
	  
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_stop_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  if(found)
	    buf[pos++] = new_text_end;
	  
	  while(isspace(*line))
	    line++;
	  
	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    buf[pos++] = new_text_start;
	    buf[pos++] = '@';
	    buf[pos++] = '@';
	    line = get_arg_with_spaces(line, tmp);
	    trans_arg(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	    buf[pos++] = '@';
	    buf[pos++] = new_text_end;
	  }
	  break;
	case 32:              /* session */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_stop_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  if(found)
	    buf[pos++] = new_text_end;
	  
	  while(isspace(*line))
	    line++;
	  
	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    line = get_arg_with_spaces(line, tmp);
	    trans_arg(tmp, tmp2);
	    pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  }
	  break;
	case 39:              /* tabadd */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "word ");
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_with_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  
	  if(found)
	    buf[pos++] = new_text_end;
	  break;
	case 40:              /* tabdelete */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "unword ");
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_with_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  
	  if(found)
	    buf[pos++] = new_text_end;
	  break;
	case 43:               /* substitute */
	case 59:               /* variable */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  if(*line == old_text_start) {
	    found = TRUE;
	    buf[pos++] = new_text_start;
	  }
	  line = get_arg_stop_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  if(found)
	    buf[pos++] = new_text_end;
	  
	  while(isspace(*line))
	    line++;
	  
	  if(*line) {
	    pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	    
	    buf[pos++] = new_text_start;
	    line = get_arg_with_spaces(line, tmp);
	    trans_arg(tmp, tmp2);
	    
	    if(num == 43 && *tmp2 == '.' && !*(tmp2 + 1))
	      pos = str_cat(buf, pos, BUFFER_SIZE, "<*GAG*>");
	    else
	      pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	    buf[pos++] = new_text_end;
	  }
	  break;
	case 44:              /* gag  */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	  pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	  
	  buf[pos++] = new_text_start;
	  line = get_arg_with_spaces(line, tmp);
	  trans_arg(tmp, tmp2);
	  pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	  buf[pos++] = new_text_end;
	  
	  buf[pos++] = ' ';
	  buf[pos++] = new_text_start;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "<*GAG*>");
	  buf[pos++] = new_text_end;
	  break;
	case 51:              /* togglesubs */
	  buf[pos++] = new_tintin_char;
	  pos = str_cat(buf, pos, BUFFER_SIZE, "ignore subs");
	  break;
	default:
	  if(old_tintin)
	    printf("Unsuported tintin III command. (%s)\n", combuf);
	  else
	    printf("Unsuported tintin++ command. (%s)\n", combuf);
	  break;
	}      /* switch */
	
	if(*str == ';') {
	  pos = str_cat(buf, pos, BUFFER_SIZE, ";");
	  str++;
	}
      } else {       /* thise might be '#<NAME> <TEXT>'  commands... */
	buf[pos++] = new_tintin_char;
	pos = str_cat(buf, pos, BUFFER_SIZE, combuf);
	pos = str_cat(buf, pos, BUFFER_SIZE, " ");
	
	found = FALSE;
	if(*line == old_text_start) {
	  found = TRUE;
	  buf[pos++] = new_text_start;
	}
	line = get_arg_with_spaces(line, tmp);
	trans(tmp, tmp2);
	pos = str_cat(buf, pos, BUFFER_SIZE, tmp2);
	
	if(found)
	  buf[pos++] = new_text_end;
	
	printf("Unknown tintin++ command. (%s)\n", combuf);
      }
      buf[pos] = '\0';
    } else {
      trans_arg(line, tmp);
      pos = str_cat(buf, pos, BUFFER_SIZE, tmp);
      if(*str == ';') {
	pos = str_cat(buf, pos, BUFFER_SIZE, ";");
	str++;
      }
    }
  }
}
